*-- Standard VFP include file
#INCLUDE "FOXPRO.H"

*-- String literals
#INCLUDE "STRINGS.H"

*-- Assorted error number constants
#INCLUDE "ERRORS.H"

*-- To avoid confusion with this.Parent:
#DEFINE SUPERCLASS PARENTCLASS
*-- This constant may be used without all letters in
*-- upper clase: this.SuperClass. This gives it the effect
*-- of appearing as a keyword. 

*-- Metadata path and table
#DEFINE METAPATH  "METADATA\"
#DEFINE METADATA   "METADATA.DBF"

#DEFINE CRLF  CHR(13) + CHR(10)
#DEFINE CR    CHR(13)
#DEFINE TAB    CHR(9)
#DEFINE FALSE  0
#DEFINE TRUE  1

*-- Ascii key codes
#DEFINE KEY_HOME            1
#DEFINE KEY_PGDOWN          3
#DEFINE KEY_PAGEDOWN        3
#DEFINE KEY_RIGHT           4
#DEFINE KEY_UP              5
#DEFINE KEY_END             6
#DEFINE KEY_DELETE          7
#DEFINE KEY_TAB             9
#DEFINE KEY_ENTER           13
#DEFINE KEY_RETURN          13
#DEFINE KEY_CARRIAGERETURN  13
#DEFINE KEY_CR              13
#DEFINE KEY_SHIFTTAB        15
#DEFINE KEY_PGUP            18
#DEFINE KEY_PAGEUP          18
#DEFINE KEY_LEFT            19
#DEFINE KEY_INSERT          22
#DEFINE KEY_CTRLEND         23
#DEFINE KEY_DOWN            24
#DEFINE KEY_ESCAPE          27
#DEFINE KEY_CTRLHOME        29
#DEFINE KEY_SPACE           32
#DEFINE KEY_EXCLAMATION     33
#DEFINE KEY_DOUBLEQUOTE     34
#DEFINE KEY_POUND           35
#DEFINE KEY_DOLLAR          36
#DEFINE KEY_PERCENT         37
#DEFINE KEY_AMPERSAND       38
#DEFINE KEY_SINGLEQUOTE     39
#DEFINE KEY_LEFTPAREN       40
#DEFINE KEY_RIGHTPAREN      41
#DEFINE KEY_ASTERISK        42
#DEFINE KEY_STAR            42
#DEFINE KEY_PLUS            43
#DEFINE KEY_COMMA           44
#DEFINE KEY_DASH            45
#DEFINE KEY_MINUS           45
#DEFINE KEY_PERIOD          46
#DEFINE KEY_SLASH           47
#DEFINE KEY_FORWARDSLASH    47
#DEFINE KEY_ZERO            48
#DEFINE KEY_0               48
#DEFINE KEY_1               49
#DEFINE KEY_ONE             49
#DEFINE KEY_SHIFTEND        49
#DEFINE KEY_TWO             50
#DEFINE KEY_2               50
#DEFINE KEY_THREE           51
#DEFINE KEY_3               51
#DEFINE KEY_SHIFTPGDOWN     51
#DEFINE KEY_SHIFTPAGEDOWN   51
#DEFINE KEY_FOUR            52
#DEFINE KEY_4               52
#DEFINE KEY_FIVE            53
#DEFINE KEY_5               53
#DEFINE KEY_SIX             54
#DEFINE KEY_6               54
#DEFINE KEY_SEVEN           55
#DEFINE KEY_7               55
#DEFINE KEY_SHIFTHOME       55
#DEFINE KEY_EIGHT           56
#DEFINE KEY_8               56
#DEFINE KEY_NINE            57
#DEFINE KEY_9               57
#DEFINE KEY_SHIFTPGUP       57
#DEFINE KEY_SHIFTPAGEUP     57
#DEFINE KEY_COLON           58
#DEFINE KEY_SEMICOLON       59
#DEFINE KEY_LESSTHAN        60
#DEFINE KEY_EQUAL            61
#DEFINE KEY_GREATERTHAN      62
#DEFINE KEY_QUESTION        63
#DEFINE KEY_AT              64
#DEFINE KEY_LEFTSQUARE      91
#DEFINE KEY_BACKSLASH        92
#DEFINE KEY_RIGHTSQUARE      93
#DEFINE KEY_CARET            94
#DEFINE KEY_UNDERSCORE      95
#DEFINE KEY_TICK            96
#DEFINE KEY_LEFTCURL        123
#DEFINE KEY_BAR              124
#DEFINE KEY_RIGHTCURL        125
#DEFINE KEY_TILDE            126
#DEFINE KEY_BACKSPACE        127
#DEFINE KEY_ALTHOME          151
#DEFINE KEY_ALTEND          159

#DEFINE KEY_SHIFT            1
#DEFINE KEY_CONTROL          2
#DEFINE KEY_ALT              4

*-- Number of elements returned by AERROR
#DEFINE AERROR_NUMCOLUMNS    7
#DEFINE AERROR_ERROR        1
#DEFINE AERROR_MESSAGE      2
#DEFINE AERROR_PARAMETER    3
#DEFINE AERROR_WORKAREA      4
#DEFINE AERROR_TRIGGER      5

*-- AERROR columns for Connectivity errors
#DEFINE AERROR_ODBCMESSAGE  3
#DEFINE AERROR_ODBCSQLSTATE  4
#DEFINE AERROR_ODBCERRORNUM  5
#DEFINE AERROR_ODBCHANDLE    7

*-- Requery function result codes
#DEFINE REQUERY_ERROR      0
#DEFINE REQUERY_SUCCESS    1

*-- CCollection class array elements
#DEFINE CHILD_CLASS      1
#DEFINE CHILD_NAME      2
#DEFINE CHILD_OBJECT    3
#DEFINE  CHILD_COUNT      4
#DEFINE CHILD_NUMBER    5

*-- Window type
#DEFINE WIN_MODELESS    0
#DEFINE WIN_MODAL        1

*-- Constants to identify file status
#DEFINE FILE_OK              0
#DEFINE FILE_BOF            -1
#DEFINE FILE_EOF            -2
#DEFINE FILE_CANCEL         -3
#DEFINE FILE_NORECORDS       -4
#DEFINE FILE_ONERECORD      -5
#DEFINE FILE_ERRORHANDLED    -6

*-- Constants to identify which trigger failed
*-- using element AERROR_TRIGGER of the array returned by 
*-- AERROR()
#DEFINE TRIGGER_INSERT 1
#DEFINE TRIGGER_UPDATE 2
#DEFINE TRIGGER_DELETE 3

*-- Constants to identify values of the form's DataSession property
#DEFINE DATASESSION_DEFAULT  1
#DEFINE DATASESSION_PRIVATE  2

*-- Constants to identify columns for view parameter processing
*-- in the CBizObj form hierarchy
#DEFINE VIEWPARMETER_NAME    1
#DEFINE VIEWPARMETER_VALUE  2

*-- Constants to indentify RowSourceType property settings
#DEFINE ROWSOURCE_NONE      0
#DEFINE ROWSOURCE_VALUE      1
#DEFINE ROWSOURCE_ALIAS      2
#DEFINE ROWSOURCE_SQL        3
#DEFINE ROWSOURCE_QUERY      4
#DEFINE ROWSOURCE_ARRAY      5
#DEFINE ROWSOURCE_FIELDS    6
#DEFINE ROWSOURCE_FILES      7
#DEFINE ROWSOURCE_STRUCTURE  8
#DEFINE ROWSOURCE_POPUP      9

*-- System registry pre-opened keys
#DEFINE HKEY_CLASSES_ROOT    -2147483648  && bitset(0,31)
#DEFINE HKEY_CURRENT_USER    -2147483647  && bitset(0,31)+1
#DEFINE HKEY_LOCAL_MACHINE  -2147483646  && bitset(0,31)+2
#DEFINE HKEY_USERS          -2147483645  && bitset(0,31)+3

#DEFINE KEY_SHARED_TOOLS_LOCATION  "Software\Microsoft\Shared Tools Location"
#DEFINE KEY_NTCURRENTVERSION      "Software\Microsoft\Windows NT\CurrentVersion"
#DEFINE KEY_WIN4CURRENTVERSION    "Software\Microsoft\Windows\CurrentVersion"


*-- Registry access rights 
#DEFINE KEY_QUERY_VALUE         1
#DEFINE KEY_SET_VALUE           2
#DEFINE KEY_CREATE_SUB_KEY      4
#DEFINE KEY_ENUMERATE_SUB_KEYS  8
#DEFINE KEY_NOTIFY              16
#DEFINE KEY_CREATE_LINK         32

*-- DEFINE KEY_READ
#UNDEF TEMP
#DEFINE TEMP        BITOR(KEY_QUERY_VALUE, KEY_ENUMERATE_SUB_KEYS)
#DEFINE KEY_READ    BITOR(TEMP, KEY_NOTIFY)
#UNDEF TEMP

*-- DEFINE KEY_WRITE
#DEFINE KEY_WRITE    BITOR(KEY_CREATE_SUB_KEY, KEY_SET_VALUE)

*-- DEFINE KEY_ALL_ACCESS 
#UNDEF TEMP
#UNDEF TEMP2
#DEFINE TEMP            BITOR(KEY_QUERY_VALUE, KEY_SET_VALUE)
#DEFINE TEMP2           BITOR(TEMP, KEY_CREATE_SUB_KEY)
#UNDEF TEMP
#DEFINE TEMP            BITOR(TEMP2, KEY_ENUMERATE_SUB_KEYS)
#UNDEF TEMP2
#DEFINE TEMP2            BITOR(TEMP, KEY_NOTIFY)
#UNDEF TEMP
#DEFINE KEY_ALL_ACCESS   BITOR(TEMP2, KEY_CREATE_LINK)

*-- Registry error codes
#DEFINE ERROR_SUCCESS    0  && OK

*-- Data types for registry keys
#DEFINE REG_SZ           1  && Data string
#DEFINE REG_BINARY       3  && Binary data in any form.
#DEFINE REG_DWORD       4  && A 32-bit number.

*-- Value of nDisposition parameter of RegCreateKeyEx()
#DEFINE REG_CREATED_NEW_KEY      1    && New Registry Key created
#DEFINE REG_OPENED_EXISTING_KEY  2    && Existing Key opened

*-- Various constants for use with SYSMETRIC function
#DEFINE SM_SCREENWIDTH    1
#DEFINE SM_SCREENHEIGHT    2

*-- Constants to help identify the return value of the 
*-- DriveType method of the CFoxtools class
#DEFINE DRIVETYPE_NONE        0
#DEFINE DRIVETYPE_FLOPPY      2
#DEFINE DRIVETYPE_HARD        3
#DEFINE DRIVETYPE_REMOVABLE    4
#DEFINE DRIVETYPE_NETWORK      4
#DEFINE DRIVETYPE_CDROM        5
#DEFINE DRIVETYPE_RAMDISK      6
